%global svnrev 502

Name:             iscsitarget
Version:          1.4.20.3
Release:          1%{?svnrev:.svn%{svnrev}}%{?dist}
Summary:          iSCSI Enterprise Target

License:          GPLv2
URL:              http://iscsitarget.sourceforge.net/
# Latest source tarball from Debian
Source0:          http://http.debian.net/debian/pool/main/i/%{name}/%{name}_%{version}%{?svnrev:+svn%{svnrev}}.orig.tar.gz

# systemd unit
Source1:          %{name}.service
Source2:          %{name}.sysconfig

# Patches from Debian
Patch0:           enable-3.12-compat.patch
Patch1:           enable-3.14-compat.patch
Patch2:           porting-3.19.patch
Patch3:           compat-3.19.patch
Patch4:           enable-3.19-compat.patch
Patch5:           fix-compat-3.13.patch
Patch6:           porting-4.3.patch
Patch7:           compat-4.3.patch
Patch8:           enable-4.3.patch

BuildRequires:    binutils
BuildRequires:    coreutils
BuildRequires:    gcc
BuildRequires:    make
BuildRequires:    patch
BuildRequires:    systemd
Requires(post):   systemd
Requires(preun):  systemd
Requires(postun): systemd
Requires:         %{name}-kmod = %{version}-%{release}

%description
%{summary}.

%files
%license COPYING
%{_sbindir}/iet*
%{_mandir}/man*/iet*
%{_unitdir}/%{name}.service
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%dir %{_sysconfdir}/iet
%config(noreplace) %{_sysconfdir}/iet/ietd.conf
%config(noreplace) %{_sysconfdir}/iet/initiators.allow
%config(noreplace) %{_sysconfdir}/iet/targets.allow
%doc %{_docdir}/%{name}/*

%post
%systemd_post %{name}.service

%preun
%systemd_preun %{name}.service

%postun
%systemd_postun_with_restart %{name}.service

# ----------------------------------------------------------------------

%package -n dkms-%{name}
Summary:          DKMS managed kernel module for iSCSI Enterprise Target
Provides:         %{name}-kmod = %{version}-%{release}
# With patches, this only works with kernel 4.4 and below
Conflicts:        kernel >= 4.5
Conflicts:        kernel-devel >= 4.5
Conflicts:        kernel-devel-uname-r >= 4.5
Requires(preun):  dkms
Requires:         dkms
Requires(post):   dkms

%if 0%{?rhel}
Requires:        perl
%endif

OrderWithRequires: kernel-devel-uname-r
# We usually don't want kernel-debug-devel
%if 0%{?fedora}
Suggests:          kernel-devel
%endif

BuildArch:       noarch

%description -n dkms-%{name}
This package provides the kernel module sources used by
DKMS to build the iSCSI Enterprise Target kernel modules.


%files -n dkms-%{name}
%license COPYING
%{_usrsrc}/%{name}-%{version}/

%post -n dkms-%{name}
if [ "$1" -ge "1" ]; then
   if [ -f /usr/lib/dkms/common.postinst ]; then
      /usr/lib/dkms/common.postinst %{name} %{version}
      exit $?
   fi   
fi

%preun -n dkms-%{name}
if [  "$(dkms status -m %{name} -v %{version})" ]; then
   dkms remove -m %{name} -v %{version} --all --rpm_safe_upgrade
fi


# ----------------------------------------------------------------------

%prep
%autosetup -n %{name}-%{version}%{?svnrev:+svn%{svnrev}} -p1


%build
make usr

%install
make install-usr install-doc install-etc DISTDIR=%{buildroot} DESTDIR=%{buildroot}

mkdir -p %{buildroot}%{_usrsrc}/%{name}-%{version}
cp -r COPYING dkms.conf include kernel patches %{buildroot}%{_usrsrc}/%{name}-%{version}
sed -i -e "s/\(PACKAGE_VERSION=\).*/\1\"%{version}\"/" %{buildroot}%{_usrsrc}/%{name}-%{version}/dkms.conf

mkdir -p %{buildroot}%{_unitdir}
install -pm 0644 %{S:1} %{buildroot}%{_unitdir}/%{name}.service

mkdir -p %{buildroot}%{_sysconfdir}/sysconfig
install -pm 0644 %{S:2} %{buildroot}%{_sysconfdir}/sysconfig/%{name}

# Get rid of legacy init scripts
rm -rf %{buildroot}%{_initddir}


%changelog
* Sun May 28 2017 Neal Gompa <ngompa13@gmail.com> - 1.4.20.3-1.svn502
- Initial packaging
